10 REMark $$chan=4
11 :
12 REMark + ---------------------------------------------------- +
13 REMark |<                   SBasic to Html                   >|
14 REMark + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
15 REMark | Converts SBasic programs to html using sb2htm        |
16 REMark | Adds line numbers to numberless code via intermed-   |
17 REMark | iary file in a temporary directory                   |
18 REMark |                                                      |
19 REMark | Add to FileInfo2, Hotkey, or use with EX:            |
20 REMark |                                                      |
21 REMark | er = FEW(<SBhtm>;"<program>_bas [;<command_line>]")  |
22 REMark |                                                      |
23 REMark | SBhtm passes the optional <command_line> to sb2htm   |
24 REMark | Use this to supply standard sb2htm cmdl parameters   |
25 REMark | (see sb2htm manual) except the -i command.           |
26 REMark |                                                      |
27 REMark | Version 1.02, pjw, 2oi5, SBASIC only!                |
28 REMark + ---------------------------------------------------- +
29 :
30 REMark       Config:
31 s2h$ = HOME_DIR$ & 'sb2htm_obj': REMark Html conversion program
32 out$ = 'dos3_':         REMark Default html output to my D:/temp/
33 tmp$ = 'ram1_sbhtmxxx': REMark Location and name of temp file
34 first% = 10: step% = 1: REMark First line and step size
35 :
36 REMark       Get input file name
37 REMark Get it either from cmdl or from Stufferbuffer
38 l% = LEN(CMD$)
39 IF l% = 0 THEN
40  fnm$ = HOT_GETSTUFF$: l% = LEN(fnm$)
41 ELSE
42  fnm$ = CMD$
43 END IF
44 IF l% < 9: Bye -12
45 :
46 REMark       Process command line(s)
47 com$= ''
48 REMark Additional command line?
49 s% = ';' INSTR fnm$
50 IF s% THEN
51  IF s% < l%: com$ = fnm$(s% + 1 TO l%)
52  l% = s% - 1: fnm$ = fnm$(1 TO l%)
53 END IF
54 :
55 REMark       Extract name from file name
56 ci = FOP_DIR(fnm$): IF ci < 0: Bye ci
57 dir$ = FNAME$(#ci): CLOSE#ci
58 ci = FOP_IN(fnm$): IF ci < 0: Bye ci
59 ld% = len(dir$)
60 nm$ = fnm$(6 + (ld% > 0) + ld% TO l% - 4)
61 :
62 REMark       Filter by extension
63 IF fnm$(l% - 2 TO l%) == 'sav' THEN
64  REMark _sav files pass straight through
65  bas = 0
66  CLOSE#ci
67 ELSE
68  REMark _bas file w/wo line number
69  IF fnm$(l% - 2 TO l%) == 'bas' THEN
70   bas = 1
71  ELSE
72   REMark Wrong file type
73   Bye -15
74  END IF
75  :
76  REMark Line numbers or not?
77  INPUT#ci; l$
78  IF NOT l$(1) INSTR '123456789' THEN
79   :
80   REMark     Process line numberless file
81   fnm$ = tmp$ & '_bas'
82   co = FOP_OVER(fnm$): IF co < 0: Bye co
83   bas = 2: i% = first%: lno$ = i%
84   BPUT#co; lno$, 32, l$, 10
85   :
86   FOR i% =  first% + step% TO 32767 STEP step%
87    IF EOF(#ci): EXIT i%
88    INPUT#ci; l$: lno$ = i%
89    BPUT#co; lno$, 32, l$, 10
90   END FOR i%
91   CLOSE#co
92  END IF
93  CLOSE#ci
94  :
95  REMark     Process non-sav files
96  REMark Use SBasic daughter to tokenise program
97  pip$ = 'pipe_p' & HEX$(JOBID, 32)
98  co = FOPEN(pip$ & 'o_2048'): IF co < 0: Bye co
99  :
100  REMark Slave will take instructions from here
101  cm$ = 'ci = fop_in(#0; "' & pip$ & 'o")'
102  :
103  REMark Start SBAS with our opening command
104  EXEP 'SBASIC'; cm$
105  :
106  REMark Tell it what we want
107  PRINT#co; 'load "' & fnm$ & '"'
108  PRINT#co; 'qsave_o "' & tmp$ & '"'
109  PRINT#co; 'beep 2,2: beep 2,2': REMark Signal success
110  PRINT#co; 'quit': REMark Job done! Get rid of slave
111  fnm$ = tmp$ & '_sav'
112 END IF
113 :
114 REMark      Create sb2htm command line
115 com$ = '-i!' & fnm$ & ' ' & com$ & ' -o' & out$ & nm$ & '.htm -t' & nm$
116 IF bas = 2: com$ = com$ & ' -noff'
117 :
118 REMark      Convert to tokenised file to html
119 Bye FEW(s2h$; com$)
121 :
122 REMark      Tidy and quit
123 DEFine PROCedure Bye(er)
124 IF er < 0: BEEP 3000,255
125 REMark Remove any temporary files
126 IF bas: DELETE fnm$
127 IF bas = 2: DELETE tmp$ & '_bas'
128 QUIT er
129 END DEFine Bye



130 :
